Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 55)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -56,5 +56,4 @@
 , m_cCUPartSizeSCModel        ( 1,             1,               NUM_PART_SIZE_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUPredModeSCModel        ( 1,             1,               NUM_PRED_MODE_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cCUAlfCtrlFlagSCModel     ( 1,             1,               NUM_ALF_CTRL_FLAG_CTX         , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUIntraPredSCModel       ( 1,             1,               NUM_ADI_CTX                   , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUChromaPredSCModel      ( 1,             1,               NUM_CHROMA_PRED_CTX           , m_contextModels + m_numContextModels, m_numContextModels)
@@ -73,28 +72,14 @@
 , m_cCUAbsSCModel             ( 1,             1,               NUM_ABS_FLAG_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cMVPIdxSCModel            ( 1,             1,               NUM_MVP_IDX_CTX               , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cALFFlagSCModel           ( 1,             1,               NUM_ALF_FLAG_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cALFUvlcSCModel           ( 1,             1,               NUM_ALF_UVLC_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cALFSvlcSCModel           ( 1,             1,               NUM_ALF_SVLC_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUAMPSCModel             ( 1,             1,               NUM_CU_AMP_CTX                , m_contextModels + m_numContextModels, m_numContextModels)
-#if !SAO_ABS_BY_PASS
-, m_cSaoUvlcSCModel           ( 1,             1,               NUM_SAO_UVLC_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
-#if SAO_MERGE_ONE_CTX
 , m_cSaoMergeSCModel      ( 1,             1,               NUM_SAO_MERGE_FLAG_CTX   , m_contextModels + m_numContextModels, m_numContextModels)
-#else
-, m_cSaoMergeLeftSCModel      ( 1,             1,               NUM_SAO_MERGE_LEFT_FLAG_CTX   , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cSaoMergeUpSCModel        ( 1,             1,               NUM_SAO_MERGE_UP_FLAG_CTX     , m_contextModels + m_numContextModels, m_numContextModels)
-#endif
+, m_cSaoTypeIdxSCModel        ( 1,             1,               NUM_SAO_TYPE_IDX_CTX          , m_contextModels + m_numContextModels, m_numContextModels)
+, m_cTransformSkipSCModel     ( 1,             2,               NUM_TRANSFORMSKIP_FLAG_CTX    , m_contextModels + m_numContextModels, m_numContextModels)
+, m_CUTransquantBypassFlagSCModel( 1,          1,               NUM_CU_TRANSQUANT_BYPASS_FLAG_CTX, m_contextModels + m_numContextModels, m_numContextModels)
 #if INTRA_BL
 , m_cIntraBLPredFlagSCModel   (1,              1,               NUM_INTRA_BL_PRED_CTX         , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
-, m_cSaoTypeIdxSCModel        ( 1,             1,               NUM_SAO_TYPE_IDX_CTX          , m_contextModels + m_numContextModels, m_numContextModels)
-, m_cTransformSkipSCModel     ( 1,             2,               NUM_TRANSFORMSKIP_FLAG_CTX    , m_contextModels + m_numContextModels, m_numContextModels)
-, m_CUTransquantBypassFlagSCModel( 1,          1,               NUM_CU_TRANSQUANT_BYPASS_FLAG_CTX, m_contextModels + m_numContextModels, m_numContextModels)
 {
   assert( m_numContextModels <= MAX_NUM_CTX_MOD );
-#if !REMOVE_FGS
-  m_iSliceGranularity = 0;
-#endif
 }
 
@@ -131,5 +116,4 @@
   m_cCUMergeFlagExtSCModel.initBuffer    ( sliceType, qp, (UChar*)INIT_MERGE_FLAG_EXT );
   m_cCUMergeIdxExtSCModel.initBuffer     ( sliceType, qp, (UChar*)INIT_MERGE_IDX_EXT );
-  m_cCUAlfCtrlFlagSCModel.initBuffer     ( sliceType, qp, (UChar*)INIT_ALF_CTRL_FLAG );
   m_cCUPartSizeSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_PART_SIZE );
   m_cCUAMPSCModel.initBuffer             ( sliceType, qp, (UChar*)INIT_CU_AMP_POS );
@@ -150,16 +134,5 @@
   m_cCUAbsSCModel.initBuffer             ( sliceType, qp, (UChar*)INIT_ABS_FLAG );
   m_cMVPIdxSCModel.initBuffer            ( sliceType, qp, (UChar*)INIT_MVP_IDX );
-  m_cALFFlagSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_ALF_FLAG );
-  m_cALFUvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_ALF_UVLC );
-  m_cALFSvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_ALF_SVLC );
-#if !SAO_ABS_BY_PASS
-  m_cSaoUvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_SAO_UVLC );
-#endif
-#if SAO_MERGE_ONE_CTX
   m_cSaoMergeSCModel.initBuffer      ( sliceType, qp, (UChar*)INIT_SAO_MERGE_FLAG );
-#else
-  m_cSaoMergeLeftSCModel.initBuffer      ( sliceType, qp, (UChar*)INIT_SAO_MERGE_LEFT_FLAG );
-  m_cSaoMergeUpSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_SAO_MERGE_UP_FLAG );
-#endif
   m_cSaoTypeIdxSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_SAO_TYPE_IDX );
 
@@ -191,5 +164,4 @@
   m_cCUMergeFlagExtSCModel.initBuffer    ( eSliceType, iQp, (UChar*)INIT_MERGE_FLAG_EXT );
   m_cCUMergeIdxExtSCModel.initBuffer     ( eSliceType, iQp, (UChar*)INIT_MERGE_IDX_EXT );
-  m_cCUAlfCtrlFlagSCModel.initBuffer     ( eSliceType, iQp, (UChar*)INIT_ALF_CTRL_FLAG );
   m_cCUPartSizeSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_PART_SIZE );
   m_cCUAMPSCModel.initBuffer             ( eSliceType, iQp, (UChar*)INIT_CU_AMP_POS );
@@ -210,16 +182,5 @@
   m_cCUAbsSCModel.initBuffer             ( eSliceType, iQp, (UChar*)INIT_ABS_FLAG );
   m_cMVPIdxSCModel.initBuffer            ( eSliceType, iQp, (UChar*)INIT_MVP_IDX );
-  m_cALFFlagSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_ALF_FLAG );
-  m_cALFUvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_ALF_UVLC );
-  m_cALFSvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_ALF_SVLC );
-#if !SAO_ABS_BY_PASS
-  m_cSaoUvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_SAO_UVLC );
-#endif
-#if SAO_MERGE_ONE_CTX
   m_cSaoMergeSCModel.initBuffer      ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_FLAG );
-#else
-  m_cSaoMergeLeftSCModel.initBuffer      ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_LEFT_FLAG );
-  m_cSaoMergeUpSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_UP_FLAG );
-#endif
   m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
   m_cCUTransSubdivFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
@@ -334,9 +295,5 @@
   prefix -= codeWord;
   codeWord=0;
-#if COEF_REMAIN_BIN_REDUCTION
   if (prefix < COEF_REMAIN_BIN_REDUCTION )
-#else
-  if (prefix < 8 )
-#endif
   {
     m_pcTDecBinIf->decodeBinsEP(codeWord,rParam);
@@ -345,11 +302,6 @@
   else
   {
-#if COEF_REMAIN_BIN_REDUCTION
     m_pcTDecBinIf->decodeBinsEP(codeWord,prefix-COEF_REMAIN_BIN_REDUCTION+rParam);
     rSymbol = (((1<<(prefix-COEF_REMAIN_BIN_REDUCTION))+COEF_REMAIN_BIN_REDUCTION-1)<<rParam)+codeWord;
-#else
-    m_pcTDecBinIf->decodeBinsEP(codeWord,prefix-8+rParam);
-    rSymbol = (((1<<(prefix-8))+8-1)<<rParam)+codeWord;
-#endif
   }
 }
@@ -366,13 +318,6 @@
 {
   UInt uiSymbol;
-  Int numSubseqIPCM = 0;
   Bool readPCMSampleFlag = false;
 
-  if(pcCU->getNumSucIPCM() > 0) 
-  {
-    readPCMSampleFlag = true;
-  }
-  else
-  {
     m_pcTDecBinIf->decodeBinTrm(uiSymbol);
 
@@ -380,9 +325,6 @@
     {
       readPCMSampleFlag = true;
-      m_pcTDecBinIf->decodeNumSubseqIPCM(numSubseqIPCM);
-      pcCU->setNumSucIPCM(numSubseqIPCM + 1);
       m_pcTDecBinIf->decodePCMAlignBits();
     }
-  }
 
   if (readPCMSampleFlag == true)
@@ -453,9 +395,5 @@
     }
 
-    pcCU->setNumSucIPCM( pcCU->getNumSucIPCM() - 1);
-    if(pcCU->getNumSucIPCM() == 0)
-    {
       m_pcTDecBinIf->resetBac();
-    }
   }
 }
@@ -494,7 +432,5 @@
   if( uiSymbol )
   {
-#if SKIP_FLAG
     pcCU->setSkipFlagSubParts( true,        uiAbsPartIdx, uiDepth );
-#endif
     pcCU->setPredModeSubParts( MODE_INTER,  uiAbsPartIdx, uiDepth );
     pcCU->setPartSizeSubParts( SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
@@ -555,5 +491,5 @@
 }
 
-Void TDecSbac::parseMergeIndex ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth )
+Void TDecSbac::parseMergeIndex ( TComDataCU* pcCU, UInt& ruiMergeIndex )
 {
   UInt uiUnaryIdx = 0;
@@ -783,20 +719,4 @@
   else 
   {
-#if !REMOVE_LMCHROMA
-    if( pcCU->getSlice()->getSPS()->getUseLMChroma() )
-    {
-      m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUChromaPredSCModel.get( 0, 0, 1 ) );
-    }
-    else
-    {
-      uiSymbol = 1;
-    }
-
-    if( uiSymbol == 0 )
-    {
-      uiSymbol = LM_CHROMA_IDX;
-    } 
-    else
-#endif
     {
       UInt uiIPredMode;
@@ -811,18 +731,14 @@
 }
 
-Void TDecSbac::parseInterDir( TComDataCU* pcCU, UInt& ruiInterDir, UInt uiAbsPartIdx, UInt uiDepth )
+Void TDecSbac::parseInterDir( TComDataCU* pcCU, UInt& ruiInterDir, UInt uiAbsPartIdx )
 {
   UInt uiSymbol;
   const UInt uiCtx = pcCU->getCtxInterDir( uiAbsPartIdx );
   ContextModel *pCtx = m_cCUInterDirSCModel.get( 0 );
-#if DISALLOW_BIPRED_IN_8x4_4x8PUS
   uiSymbol = 0;
   if (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N || pcCU->getHeight(uiAbsPartIdx) != 8 )
   {
-#endif
     m_pcTDecBinIf->decodeBin( uiSymbol, *( pCtx + uiCtx ) );
-#if DISALLOW_BIPRED_IN_8x4_4x8PUS
-  }
-#endif
+  }
 
   if( uiSymbol )
@@ -841,5 +757,5 @@
 }
 
-Void TDecSbac::parseRefFrmIdx( TComDataCU* pcCU, Int& riRefFrmIdx, UInt uiAbsPartIdx, UInt uiDepth, RefPicList eRefList )
+Void TDecSbac::parseRefFrmIdx( TComDataCU* pcCU, Int& riRefFrmIdx, RefPicList eRefList )
 {
   UInt uiSymbol;
@@ -850,5 +766,4 @@
     if( uiSymbol )
     {
-#if REF_IDX_BYPASS
       UInt uiRefNum = pcCU->getSlice()->getNumRefIdx( eRefList ) - 2;
       pCtx++;
@@ -870,8 +785,4 @@
       }
       uiSymbol = ui + 1;
-#else
-      xReadUnaryMaxSymbol( uiSymbol, pCtx + 1, 1, pcCU->getSlice()->getNumRefIdx( eRefList )-2 );
-      uiSymbol++;
-#endif
     }
     riRefFrmIdx = uiSymbol;
@@ -958,5 +869,5 @@
 }
 
-Void TDecSbac::parseQtRootCbf( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt& uiQtRootCbf )
+Void TDecSbac::parseQtRootCbf( UInt uiAbsPartIdx, UInt& uiQtRootCbf )
 {
   UInt uiSymbol;
@@ -982,5 +893,4 @@
   Int  iDQp;
   
-#if CU_DQP_TU_EG
   UInt uiSymbol;
 
@@ -1010,31 +920,4 @@
     qp = pcCU->getRefQP(uiAbsPartIdx);
   }
-#else
-  m_pcTDecBinIf->decodeBin( uiDQp, m_cCUDeltaQpSCModel.get( 0, 0, 0 ) );
-  
-  if ( uiDQp == 0 )
-  {
-    qp = pcCU->getRefQP(uiAbsPartIdx);
-  }
-  else
-  {
-    UInt uiSign;
-    Int qpBdOffsetY = pcCU->getSlice()->getSPS()->getQpBDOffsetY();
-    m_pcTDecBinIf->decodeBinEP(uiSign);
-
-    UInt uiMaxAbsDQpMinus1 = 24 + (qpBdOffsetY/2) + (uiSign);
-    UInt uiAbsDQpMinus1;
-    xReadUnaryMaxSymbol (uiAbsDQpMinus1,  &m_cCUDeltaQpSCModel.get( 0, 0, 1 ), 1, uiMaxAbsDQpMinus1);
-
-    iDQp = uiAbsDQpMinus1 + 1;
-
-    if(uiSign)
-    {
-      iDQp = -iDQp;
-    }
-
-    qp = (((Int) pcCU->getRefQP( uiAbsPartIdx ) + iDQp + 52 + 2*qpBdOffsetY )%(52+qpBdOffsetY)) - qpBdOffsetY;
-  }
-#endif
   pcCU->setQPSubParts(qp, uiAbsPartIdx, uiDepth);  
   pcCU->setCodedQP(qp);
@@ -1044,5 +927,5 @@
 {
   UInt uiSymbol;
-  const UInt uiCtx = pcCU->getCtxQtCbf( uiAbsPartIdx, eType, uiTrDepth );
+  const UInt uiCtx = pcCU->getCtxQtCbf( eType, uiTrDepth );
   m_pcTDecBinIf->decodeBin( uiSymbol , m_cCUQtCbfSCModel.get( 0, eType ? TEXT_CHROMA: eType, uiCtx ) );
   
@@ -1068,10 +951,4 @@
     return;
   }
-#if !INTER_TRANSFORMSKIP
-  if(!pcCU->isIntra(uiAbsPartIdx))
-  {
-    return;
-  }
-#endif
   if(width != 4 || height != 4)
   {
@@ -1205,9 +1082,5 @@
     uiHeight = pcCU->getSlice()->getSPS()->getMaxTrSize();
   }
-#if PPS_TS_FLAG
   if(pcCU->getSlice()->getPPS()->getUseTransformSkip())
-#else
-  if(pcCU->getSlice()->getSPS()->getUseTransformSkip())
-#endif
   {
     parseTransformSkipFlags( pcCU, uiAbsPartIdx, uiWidth, uiHeight, uiDepth, eTType);
@@ -1221,10 +1094,4 @@
   const UInt  uiMaxNumCoeffM1   = uiMaxNumCoeff - 1;
   UInt uiScanIdx = pcCU->getCoefScanIdx(uiAbsPartIdx, uiWidth, eTType==TEXT_LUMA, pcCU->isIntra(uiAbsPartIdx));
-  int blockType = uiLog2BlockSize;
-  if (uiWidth != uiHeight)
-  {
-    uiScanIdx = SCAN_DIAG;
-    blockType = 4;
-  }
   
   //===== decode last significant =====
@@ -1235,23 +1102,6 @@
 
   //===== decode significance flags =====
-  UInt uiScanPosLast   = uiBlkPosLast;
-  if (uiScanIdx == SCAN_ZIGZAG)
-  {
-    // Map zigzag to diagonal scan
-    uiScanIdx = SCAN_DIAG;
-  }
-#if REMOVE_NSQT
-  const UInt *scan = g_auiSigLastScan[ uiScanIdx ][ uiLog2BlockSize-1 ];
-#else
-  const UInt * scan;
-  if (uiWidth == uiHeight)
-  {
-    scan = g_auiSigLastScan[ uiScanIdx ][ uiLog2BlockSize-1 ];
-  }
-  else
-  {
-    scan = g_sigScanNSQT[ uiLog2BlockSize - 2 ];
-  }
-#endif
+  UInt uiScanPosLast = uiBlkPosLast;
+  const UInt *scan   = g_auiSigLastScan[ uiScanIdx ][ uiLog2BlockSize-1 ];
   for( uiScanPosLast = 0; uiScanPosLast < uiMaxNumCoeffM1; uiScanPosLast++ )
   {
@@ -1267,9 +1117,5 @@
 
   const Int  iLastScanSet      = uiScanPosLast >> LOG2_SCAN_SET_SIZE;
-#if REMOVE_NUM_GREATER1
   UInt c1 = 1;
-#else
-  UInt uiNumOne                = 0;
-#endif
   UInt uiGoRiceParam           = 0;
 
@@ -1289,7 +1135,4 @@
   const UInt uiNumBlkSide = uiWidth >> (MLS_CG_SIZE >> 1);
   const UInt * scanCG;
-#if !REMOVE_NSQT
-  if (uiWidth == uiHeight)
-#endif
   {
     scanCG = g_auiSigLastScan[ uiScanIdx ][ uiLog2BlockSize > 3 ? uiLog2BlockSize-2-1 : 0  ];    
@@ -1303,10 +1146,4 @@
     }
   }
-#if !REMOVE_NSQT
-  else
-  {
-    scanCG = g_sigCGScanNSQT[ uiLog2BlockSize - 2 ];
-  }
-#endif
   Int  iScanPosSig             = (Int) uiScanPosLast;
   for( Int iSubSet = iLastScanSet; iSubSet >= 0; iSubSet-- )
@@ -1332,11 +1169,4 @@
     Int iCGPosY   = iCGBlkPos / uiNumBlkSide;
     Int iCGPosX   = iCGBlkPos - (iCGPosY * uiNumBlkSide);
-#if !REMOVAL_8x2_2x8_CG
-    if( uiWidth == 8 && uiHeight == 8 && (uiScanIdx == SCAN_HOR || uiScanIdx == SCAN_VER) )
-    {
-      iCGPosY = (uiScanIdx == SCAN_HOR ? iCGBlkPos : 0);
-      iCGPosX = (uiScanIdx == SCAN_VER ? iCGBlkPos : 0);
-    }
-#endif
     if( iSubSet == iLastScanSet || iSubSet == 0)
     {
@@ -1346,5 +1176,5 @@
     {
       UInt uiSigCoeffGroup;
-      UInt uiCtxSig  = TComTrQuant::getSigCoeffGroupCtxInc( uiSigCoeffGroupFlag, iCGPosX, iCGPosY, uiScanIdx, uiWidth, uiHeight );
+      UInt uiCtxSig  = TComTrQuant::getSigCoeffGroupCtxInc( uiSigCoeffGroupFlag, iCGPosX, iCGPosY, uiWidth, uiHeight );
       m_pcTDecBinIf->decodeBin( uiSigCoeffGroup, baseCoeffGroupCtx[ uiCtxSig ] );
       uiSigCoeffGroupFlag[ iCGBlkPos ] = uiSigCoeffGroup;
@@ -1365,9 +1195,5 @@
         if( iScanPosSig > iSubPos || iSubSet == 0  || numNonZero )
         {
-#if REMOVAL_8x2_2x8_CG
-          uiCtxSig  = TComTrQuant::getSigCtxInc( patternSigCtx, uiScanIdx, uiPosX, uiPosY, blockType, uiWidth, uiHeight, eTType );
-#else
-          uiCtxSig  = TComTrQuant::getSigCtxInc( patternSigCtx, uiPosX, uiPosY, blockType, uiWidth, uiHeight, eTType );
-#endif
+          uiCtxSig  = TComTrQuant::getSigCtxInc( patternSigCtx, uiScanIdx, uiPosX, uiPosY, uiLog2BlockSize, eTType );
           m_pcTDecBinIf->decodeBin( uiSig, baseCtx[ uiCtxSig ] );
         }
@@ -1394,22 +1220,11 @@
       Bool signHidden = ( lastNZPosInCG - firstNZPosInCG >= SBH_THRESHOLD );
       absSum = 0;
-#if !REMOVE_NUM_GREATER1
-      UInt c1 = 1;
-#endif
       UInt uiCtxSet    = (iSubSet > 0 && eTType==TEXT_LUMA) ? 2 : 0;
       UInt uiBin;
-#if REMOVE_NUM_GREATER1
       if( c1 == 0 )
-#else
-      if( uiNumOne > 0 )
-#endif
       {
         uiCtxSet++;
       }
-#if REMOVE_NUM_GREATER1
       c1 = 1;
-#else
-      uiNumOne       >>= 1;
-#endif
       ContextModel *baseCtxMod = ( eTType==TEXT_LUMA ) ? m_cCUOneSCModel.get( 0, 0 ) + 4 * uiCtxSet : m_cCUOneSCModel.get( 0, 0 ) + NUM_ONE_FLAG_CTX_LUMA + 4 * uiCtxSet;
       Int absCoeff[SCAN_SET_SIZE];
@@ -1480,7 +1295,4 @@
           {
             iFirstCoeff2 = 0;
-#if !REMOVE_NUM_GREATER1
-            uiNumOne++;
-#endif
           }
         }
@@ -1510,10 +1322,4 @@
       }
     }
-#if !REMOVE_NUM_GREATER1
-    else
-    {
-      uiNumOne >>= 1;
-    }
-#endif
   }
   
@@ -1532,9 +1338,5 @@
   UInt code;
   Int  i;
-#if SAO_ABS_BY_PASS
   m_pcTDecBinIf->decodeBinEP( code );
-#else
-  m_pcTDecBinIf->decodeBin( code, m_cSaoUvlcSCModel.get( 0, 0, 0 ) );
-#endif
   if ( code == 0 )
   {
@@ -1546,9 +1348,5 @@
   while (1)
   {
-#if SAO_ABS_BY_PASS
     m_pcTDecBinIf->decodeBinEP( code );
-#else
-    m_pcTDecBinIf->decodeBin( code, m_cSaoUvlcSCModel.get( 0, 0, 1 ) );
-#endif
     if ( code == 0 )
     {
@@ -1564,45 +1362,17 @@
   val = i;
 }
-#if SAO_TYPE_CODING
 Void TDecSbac::parseSaoUflc (UInt uiLength, UInt&  riVal)
 {
   m_pcTDecBinIf->decodeBinsEP ( riVal, uiLength );
 }
-#else
-Void TDecSbac::parseSaoUflc (UInt&  riVal)
-{
-  m_pcTDecBinIf->decodeBinsEP ( riVal, 5 );
-}
-#endif
-#if SAO_MERGE_ONE_CTX
 Void TDecSbac::parseSaoMerge (UInt&  ruiVal)
-#else
-Void TDecSbac::parseSaoMergeLeft (UInt&  ruiVal, UInt uiCompIdx)
-#endif
 {
   UInt uiCode;
-#if SAO_MERGE_ONE_CTX
   m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeSCModel.get( 0, 0, 0 ) );
-#else
-#if SAO_SINGLE_MERGE
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeLeftSCModel.get( 0, 0, 0 ) );
-#else
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeLeftSCModel.get( 0, 0, uiCompIdx ) );
-#endif
-#endif
   ruiVal = (Int)uiCode;
 }
-#if !SAO_MERGE_ONE_CTX
-Void TDecSbac::parseSaoMergeUp (UInt&  ruiVal)
+Void TDecSbac::parseSaoTypeIdx (UInt&  ruiVal)
 {
   UInt uiCode;
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeUpSCModel.get( 0, 0, 0 ) );
-  ruiVal = (Int)uiCode;
-}
-#endif
-Void TDecSbac::parseSaoTypeIdx (UInt&  ruiVal)
-{
-  UInt uiCode;
-#if SAO_TYPE_CODING
   m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
   if (uiCode == 0) 
@@ -1622,24 +1392,4 @@
     }
   }
-#else
-  Int  i;
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
-  if ( uiCode == 0 )
-  {
-    ruiVal = 0;
-    return;
-  }
-  i=1;
-  while (1)
-  {
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 1 ) );
-    if ( uiCode == 0 )
-    {
-      break;
-    }
-    i++;
-  }
-  ruiVal = i;
-#endif
 }
 
@@ -1651,16 +1401,5 @@
   if (psDst->typeIdx != -1)
   {
-#if SAO_TYPE_CODING
     psDst->subTypeIdx = psSrc->subTypeIdx ;
-#else
-    if (psDst->typeIdx == SAO_BO)
-    {
-      psDst->bandPosition = psSrc->bandPosition ;
-    }
-    else
-    {
-      psDst->bandPosition = 0;
-    }
-#endif
     psDst->length  = psSrc->length;
     for (i=0;i<psDst->length;i++)
@@ -1679,9 +1418,5 @@
 }
 
-#if SAO_TYPE_SHARING
 Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam, UInt compIdx)
-#else
-Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam)
-#endif
 {
   UInt uiSymbol;
@@ -1695,33 +1430,22 @@
   }; 
 
-#if SAO_TYPE_SHARING
-if (compIdx==2)
-{
-uiSymbol = (UInt)( psSaoLcuParam->typeIdx + 1);
-}
-else
-{
-parseSaoTypeIdx(uiSymbol);
-}
-#else
-  parseSaoTypeIdx(uiSymbol);
-#endif
+  if (compIdx==2)
+  {
+    uiSymbol = (UInt)( psSaoLcuParam->typeIdx + 1);
+  }
+  else
+  {
+    parseSaoTypeIdx(uiSymbol);
+  }
   psSaoLcuParam->typeIdx = (Int)uiSymbol - 1;
   if (uiSymbol)
   {
     psSaoLcuParam->length = iTypeLength[psSaoLcuParam->typeIdx];
-#if FULL_NBIT
-    Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + (g_uiBitDepth-8)-5),5) );
-#else
-    Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + g_uiBitIncrement-5),5) );
-#endif
+
+    Int bitDepth = compIdx ? g_bitDepthC : g_bitDepthY;
+    Int offsetTh = 1 << min(bitDepth - 5,5);
 
     if( psSaoLcuParam->typeIdx == SAO_BO )
     {
-#if !SAO_TYPE_CODING
-    // Parse Left Band Index
-    parseSaoUflc( uiSymbol );
-    psSaoLcuParam->bandPosition = uiSymbol;
-#endif
       for(Int i=0; i< psSaoLcuParam->length; i++)
       {
@@ -1740,8 +1464,6 @@
         }
       }
-#if SAO_TYPE_CODING
       parseSaoUflc(5, uiSymbol );
       psSaoLcuParam->subTypeIdx = uiSymbol;
-#endif
     }
     else if( psSaoLcuParam->typeIdx < 4 )
@@ -1751,6 +1473,4 @@
       parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[2] = -(Int)uiSymbol;
       parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[3] = -(Int)uiSymbol;
-#if SAO_TYPE_CODING
-#if SAO_TYPE_SHARING
      if (compIdx != 2)
      {
@@ -1759,10 +1479,4 @@
        psSaoLcuParam->typeIdx += psSaoLcuParam->subTypeIdx;
      }
-#else
-     parseSaoUflc(2, uiSymbol );
-     psSaoLcuParam->subTypeIdx = uiSymbol;
-     psSaoLcuParam->typeIdx += psSaoLcuParam->subTypeIdx;
-#endif
-#endif
    }
   }
@@ -1777,14 +1491,9 @@
   Int iAddr = pcCU->getAddr();
   UInt uiSymbol;
-#if SAO_SINGLE_MERGE
   for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
   {
     pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag    = 0;
     pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag  = 0;
-#if SAO_TYPE_CODING
     pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx     = 0;
-#else
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].bandPosition   = 0;
-#endif
     pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx        = -1;
     pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[0]     = 0;
@@ -1794,19 +1503,10 @@
 
   }
-#if SAO_TYPE_SHARING
  if (pSaoParam->bSaoFlag[0] || pSaoParam->bSaoFlag[1] )
-#else
- if (pSaoParam->bSaoFlag[0] || pSaoParam->bSaoFlag[1] || pSaoParam->bSaoFlag[2])
-#endif
   {
     if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
     {
-#if SAO_MERGE_ONE_CTX
       parseSaoMerge(uiSymbol); 
       pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag = (Bool)uiSymbol;  
-#else
-      parseSaoMergeLeft(uiSymbol, 0); 
-      pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag = (Bool)uiSymbol;   
-#endif
     }
     if (pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag==0)
@@ -1814,41 +1514,17 @@
       if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
       {
-#if SAO_MERGE_ONE_CTX
         parseSaoMerge(uiSymbol);
         pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag = (Bool)uiSymbol;
-#else
-        parseSaoMergeUp(uiSymbol);
-        pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag = (Bool)uiSymbol;
-#endif
-      }
-    }
-  }
-#endif
+      }
+    }
+  }
 
   for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
   {
-#if !SAO_SINGLE_MERGE
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag    = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag  = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].bandPosition   = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx        = -1;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[0]     = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[1]     = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[2]     = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[3]     = 0;
-#endif
-#if SAO_TYPE_SHARING
     if ((iCompIdx == 0  && pSaoParam->bSaoFlag[0]) || (iCompIdx > 0  && pSaoParam->bSaoFlag[1]) )
-#else
-    if (pSaoParam->bSaoFlag[iCompIdx])
-#endif
     {
       if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
       {
-#if SAO_SINGLE_MERGE
         pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag;
-#else
-        parseSaoMergeLeft(uiSymbol,iCompIdx); pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = (Int)uiSymbol;
-#endif
       }
       else
@@ -1861,9 +1537,5 @@
         if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
         {
-#if SAO_SINGLE_MERGE
           pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag;
-#else
-          parseSaoMergeUp(uiSymbol);  pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = uiSymbol;
-#endif
         }
         else
@@ -1873,10 +1545,6 @@
         if (!pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag)
         {
-#if SAO_TYPE_SHARING
           pSaoParam->saoLcuParam[2][iAddr].typeIdx = pSaoParam->saoLcuParam[1][iAddr].typeIdx;
           parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]), iCompIdx);
-#else
-          parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]));
-#endif
         }
         else
@@ -1893,29 +1561,8 @@
     {
       pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx = -1;
-#if SAO_TYPE_CODING
       pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx = 0;
-#else
-      pSaoParam->saoLcuParam[iCompIdx][iAddr].bandPosition = 0;
-#endif
-    }
-  }
-}
-
-#if !REMOVE_ALF
-Void TDecSbac::parseAlfCtrlFlag (Int compIdx, UInt& code)
-{
-  UInt decodedSymbol;
-  m_pcTDecBinIf->decodeBin( decodedSymbol, m_cCUAlfCtrlFlagSCModel.get( 0, 0, 0 ) );
-  code = decodedSymbol;
-
-  DTRACE_CABAC_VL( g_nSymbolCounter++ )
-  DTRACE_CABAC_T( "parseAlfCtrlFlag()" )
-  DTRACE_CABAC_T( "\tsymbol=" )
-  DTRACE_CABAC_V( decodedSymbol )
-  DTRACE_CABAC_T( "\tcompIdx=" )
-  DTRACE_CABAC_V( compIdx )
-  DTRACE_CABAC_T( "\n" )
-}
-#endif
+    }
+  }
+}
 
 /**
@@ -1947,11 +1594,3 @@
   xCopyContextsFrom(pScr);
 }
-
-Void TDecSbac::decodeFlush ( )
-{
-  UInt uiBit;
-  m_pcTDecBinIf->decodeBinTrm(uiBit);
-  m_pcTDecBinIf->flush();
-
-}
 //! \}
Index: trunk/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 55)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -58,6 +58,4 @@
 // ====================================================================================================================
 
-class SEImessages;
-
 /// SBAC decoder class
 class TDecSbac : public TDecEntropyIf
@@ -74,37 +72,20 @@
   Void xCopyFrom           ( TDecSbac* pSrc );
   Void xCopyContextsFrom       ( TDecSbac* pSrc );
-  Void decodeFlush();
 
   Void  resetEntropy (TComSlice* pSlice );
   Void  setBitstream              ( TComInputBitstream* p  ) { m_pcBitstream = p; m_pcTDecBinIf->init( p ); }
-  Void  parseVPS                  ( TComVPS* pcVPS )  {}
-  Void  parseSPS                  ( TComSPS* pcSPS         ) {}
-  Void  parsePPS                  ( TComPPS* pcPPS         ) {}
-#if !REMOVE_APS
-  Void  parseAPS                  ( TComAPS* pAPS          ) {}
-#endif
+  Void  parseVPS                  ( TComVPS* /*pcVPS*/ ) {}
+  Void  parseSPS                  ( TComSPS* /*pcSPS*/ ) {}
+  Void  parsePPS                  ( TComPPS* /*pcPPS*/ ) {}
 
-  Void  parseSliceHeader          ( TComSlice*& rpcSlice, ParameterSetManagerDecoder *parameterSetManager) {}
+  Void  parseSliceHeader          ( TComSlice*& /*rpcSlice*/, ParameterSetManagerDecoder* /*parameterSetManager*/) {}
   Void  parseTerminatingBit       ( UInt& ruiBit );
   Void  parseMVPIdx               ( Int& riMVPIdx          );
   Void  parseSaoMaxUvlc           ( UInt& val, UInt maxSymbol );
-#if SAO_MERGE_ONE_CTX
   Void  parseSaoMerge         ( UInt&  ruiVal   );
-#else
-  Void  parseSaoMergeLeft         ( UInt&  ruiVal, UInt uiCompIdx   );
-  Void  parseSaoMergeUp           ( UInt&  ruiVal  );
-#endif
   Void  parseSaoTypeIdx           ( UInt&  ruiVal  );
-#if SAO_TYPE_CODING
   Void  parseSaoUflc              ( UInt uiLength, UInt& ruiVal     );
-#else
-  Void  parseSaoUflc              ( UInt& ruiVal           );
-#endif
   Void  parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp);
-#if SAO_TYPE_SHARING
   Void  parseSaoOffset            (SaoLcuParam* psSaoLcuParam, UInt compIdx);
-#else
-  Void  parseSaoOffset            (SaoLcuParam* psSaoLcuParam);
-#endif
 private:
   Void  xReadUnarySymbol    ( UInt& ruiSymbol, ContextModel* pcSCModel, Int iOffset );
@@ -116,19 +97,5 @@
   TDecBinIf*        m_pcTDecBinIf;
  
-#if !REMOVE_FGS
-  Int           m_iSliceGranularity; //!< slice granularity
-#endif
-  
 public:
-#if !REMOVE_ALF
-  Void parseAlfCtrlFlag   (Int compIdx, UInt& code);
-#endif
-#if !REMOVE_FGS
-  /// set slice granularity
-  Void setSliceGranularity(Int iSliceGranularity)  {m_iSliceGranularity = iSliceGranularity;}
-
-  /// get slice granularity
-  Int  getSliceGranularity()                       {return m_iSliceGranularity;             }
-#endif
   
   Void parseSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
@@ -136,5 +103,5 @@
   Void parseSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   Void parseMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
-  Void parseMergeIndex    ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth );
+  Void parseMergeIndex    ( TComDataCU* pcCU, UInt& ruiMergeIndex );
   Void parsePartSize      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   Void parsePredMode      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
@@ -144,11 +111,11 @@
   Void parseIntraDirChroma( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   
-  Void parseInterDir      ( TComDataCU* pcCU, UInt& ruiInterDir, UInt uiAbsPartIdx, UInt uiDepth );
-  Void parseRefFrmIdx     ( TComDataCU* pcCU, Int& riRefFrmIdx, UInt uiAbsPartIdx, UInt uiDepth, RefPicList eRefList );
+  Void parseInterDir      ( TComDataCU* pcCU, UInt& ruiInterDir, UInt uiAbsPartIdx );
+  Void parseRefFrmIdx     ( TComDataCU* pcCU, Int& riRefFrmIdx, RefPicList eRefList );
   Void parseMvd           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth, RefPicList eRefList );
   
   Void parseTransformSubdivFlag( UInt& ruiSubdivFlag, UInt uiLog2TransformBlockSize );
   Void parseQtCbf         ( TComDataCU* pcCU, UInt uiAbsPartIdx, TextType eType, UInt uiTrDepth, UInt uiDepth );
-  Void parseQtRootCbf     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt& uiQtRootCbf );
+  Void parseQtRootCbf     ( UInt uiAbsPartIdx, UInt& uiQtRootCbf );
   
   Void parseDeltaQP       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
@@ -162,5 +129,5 @@
   Void updateContextTables( SliceType eSliceType, Int iQp );
 
-  Void  parseScalingList ( TComScalingList* scalingList ) {}
+  Void  parseScalingList ( TComScalingList* /*scalingList*/ ) {}
 
 #if INTRA_BL
@@ -179,5 +146,4 @@
   ContextModel3DBuffer m_cCUPartSizeSCModel;
   ContextModel3DBuffer m_cCUPredModeSCModel;
-  ContextModel3DBuffer m_cCUAlfCtrlFlagSCModel;
   ContextModel3DBuffer m_cCUIntraPredSCModel;
   ContextModel3DBuffer m_cCUChromaPredSCModel;
@@ -199,23 +165,12 @@
   ContextModel3DBuffer m_cMVPIdxSCModel;
   
-  ContextModel3DBuffer m_cALFFlagSCModel;
-  ContextModel3DBuffer m_cALFUvlcSCModel;
-  ContextModel3DBuffer m_cALFSvlcSCModel;
   ContextModel3DBuffer m_cCUAMPSCModel;
-#if !SAO_ABS_BY_PASS
-  ContextModel3DBuffer m_cSaoUvlcSCModel;
-#endif
-#if SAO_MERGE_ONE_CTX
   ContextModel3DBuffer m_cSaoMergeSCModel;
-#else
-  ContextModel3DBuffer m_cSaoMergeLeftSCModel;
-  ContextModel3DBuffer m_cSaoMergeUpSCModel;
-#endif
+  ContextModel3DBuffer m_cSaoTypeIdxSCModel;
+  ContextModel3DBuffer m_cTransformSkipSCModel;
+  ContextModel3DBuffer m_CUTransquantBypassFlagSCModel;
 #if INTRA_BL
   ContextModel3DBuffer m_cIntraBLPredFlagSCModel;
 #endif
-  ContextModel3DBuffer m_cSaoTypeIdxSCModel;
-  ContextModel3DBuffer m_cTransformSkipSCModel;
-  ContextModel3DBuffer m_CUTransquantBypassFlagSCModel;
 };
 
